'' VGA_1024.spin
''
'' MODIFIED BY VINCE BRIEL FOR POCKETERM FEATURES
'' MODIIFED BY JEFF LEDGER / AKA OLDBITCOLLECTOR
''

CON
  cols          = 80 '128                               ' number of screen columns
  rows          = 40 '64                                ' number of screen rows
  chars         = rows*cols                             ' number of screen characters
  chars1        = rows*cols                             ' adjusted value for split screen effect
  cols1         = 81                                    ' adjusted value for 80th character

VAR
  byte  screen[chars]           ' screen character buffer
  word  colors[rows]            ' color specs for each screen row (see ColorPtr description above)
  byte  cursor[6]               ' cursor info array (see CursorPtr description above)
  long  sync, loc, xloc, yloc   ' sync used by VGA routine, others are local screen pointers
  byte  inverse
  byte  invs
  Byte VT100          ' for VT100 static code
  Byte wyse
  Byte Byte1
  Byte Byte2
  Byte Byte3
  Byte Byte4
  Byte Byte5
  Byte Byte6
  Byte Byte7
  Byte W1
  Byte W2
  Byte W3
  Byte LNM
  long Parameters[6]

PUB StoreParameters(BasePin) ' store parameters in an array so only need to pass one value to the overlay
   Parameters[0] := BasePin 
   Parameters[1] := @screen
   Parameters[2] := @colors
   Parameters[3] := @cursor
   Parameters[4] := @sync
   Parameters[5] := @font
   return @Parameters    ' return location of this array
           
    
PUB StartCursor
''init cursor attributes
  cursor[2] := %110             ' init cursor to underscore with slow blink
  xloc := cursor[0] := 0        ' cursor at top left 0,0
  yloc := cursor[1] := 0
  loc  := xloc + yloc*cols

PUB inv(c)
  inverse:=c          ' send 1 to select inverse, set 0 to select normal
PUB cursorset(c) | i
  i:=%000
  if c == 1
    i:= %001
  if c == 2
    i:= %010
  if c == 3
    i:= %011
  if c == 4
    i:= %101
  if c == 5
    i:= %110
  if c == 6
    i:= %111
  if c == 7
    i:= %000  
  cursor[2] := i
PUB bin(value, digits)

'' Print a binary number, specify number of digits

  repeat while digits > 32
    out("0")
    digits--

  value <<= 32 - digits

  repeat digits
    out((value <-= 1) & 1 + "0")


PUB insertat(amount) | i,j,len
    len := (cols - xloc) - amount     
    i := @screen                                     'starting location
    i := i + loc
    j := i + amount                                   'new location which is plus 1?
    bytemove(j,i, len)                           ' move chars over one
    bytefill(i, $20,amount)

PUB delp(amount) | i,j,len

    len := (cols - xloc) - amount     
    i := @screen                                     'starting location
    i := i + loc
    j := i + amount                                   'new location which is plus 1?
    bytemove(i,j, len)                           ' move chars over one
    'bytefill(j, $20,amount)

PUB ClearScreen | x,y
  longfill(@screen, $20202020, chars/4)
  xloc := cursor[0] := 0
  yloc := cursor[1] := 0
  loc  := xloc + yloc*cols


PUB clearlinefromcursor | x,xx,y, loop

   y := cursor[1] 'yloc
   x := cursor[0] 'xloc
  xx := cursor[0] 'xloc

  repeat until xx == 80
    out(32)
    xx++

  yloc := cursor[1] := y
  xloc := cursor[0] := x
  loc  := xloc + yloc*cols

PUB clearlinetocursor | x,y,loop

  x := xloc
  xloc := loop := 0
  loc  := xloc + yloc*cols
  repeat until loop == x
     out(32)
     loop++
  xloc := x
  loc  := xloc + yloc*cols

PUB clearline | x,y

  x := xloc
  xloc := 0
  loc  := xloc + yloc*cols
  repeat 80
     out(32)
  xloc := x
  loc  := xloc + yloc*cols

PUB clsfromcursordown | x,y,loop,i
  x:=xloc
  y:=yloc
  i := rows - y
  i--
  loop := 0
  repeat until xloc == 80
     out(32)
  xloc := 0
  yloc++
  loc  := xloc + yloc*cols
  loop := yloc
  repeat until loop == rows
     str(string("                                                                                "))
     loop++
  xloc := cursor[0] := x
  yloc := cursor[1] := y
  loc  := xloc + yloc*cols


PUB clstocursor | x,y,z,loop 'working correctly now
  y := yloc
  x := xloc
  xloc :=0
  loc  := xloc + yloc*cols
  repeat until xloc == x
     out(32)
  yloc := 0
  z:=0
  repeat until z == y
    yloc := z
    xloc :=0
    loc := xloc + yloc*cols
    str(string("                                                                                "))
    z:= z + 1                                       
  xloc := cursor[0] := x
  yloc := cursor[1] := y
  loc  := xloc + yloc*cols
  
PUB home

  xloc := cursor[0] := 0 'right & left
  yloc := cursor[1] := 0 'from top
  loc  := xloc + yloc*cols

PUB color(ColorVal) | i
''reset screen colors
  repeat i from 0 to rows - 1
    colors[i] := $0000 + ColorVal

PUB clrbtm(ColorVal) | i
   repeat i from 36 to rows - 1                         'was 35
    colors[i] := $0000 + ColorVal
PUB rowcolor(ColorVal, row)
'' reset row color to colorval
  if row > rows-1
    row := rows-1

   colors[row] := $0000 + ColorVal


PUB cursloc(x, y)
'' move cursor to x, y position

  xloc := cursor[0] := x
  yloc := cursor[1] := y
  loc  := xloc + yloc*cols
PUB cursrow(y)
'' move cursor to y position

  yloc := cursor[1] := y
  loc  := xloc + yloc*cols

PUB dec(value) | i

'' Print a decimal number

  if value < 0
    -value
    out("-")

  i := 1_000_000_000

  repeat 10
    if value => i
      out(value/i + "0")
      value //= i
      result~~
    elseif result or i == 1
      out("0")
    i /= 10     

PUB hex(value, digits)

'' Print a hexadecimal number, specify number of digits

  repeat while digits > 8
    out("0")
    digits--

  value <<= (8 - digits) << 2

  repeat digits
    out(lookupz((value <-= 4) & $f : "0".."9", "A".."F"))

PUB scrollD | i,len,y,dest,source

    y := yloc * cols
    i := @screen
    dest := i + y
    source := dest + cols
    len := (chars1-y-80)/4
    longmove(source, dest, len)
    longfill(dest,$20202020, cols/4)



PUB scrollM  | i,y,dest,source,len
   'longmove(dest,source,length)
    y := yloc * cols
    i := @screen
    dest := i + y
    'len := (chars1-y)/4
    len := (chars1-y-80)/4
    source := dest + cols
    longmove(dest,source,len)
    

PRI newline | i, j, len
  if ++yloc == rows                           ' if last line on screen, shift all up       was just rows
    yloc--                                    ' reset yloc it at bottom of screen
    i := @screen
    i += cols
    len := (chars1 - cols)/4           'was chars now rows*cols    (rows*cols)
    longmove(@screen, i, len)                 ' shift screen up one line
    
    i := @screen
    i += ((rows*cols) - cols)              ' set "i" for use below     WAS CHARS NOW ROWSNOW*COLS

  else                                        ' if not last line, shift lines down
    i := @screen
    i += (rows - 2)*cols                      ' init ptr to start of next-to-last line  was -2 now -1

    'if yloc < rows - 1
    '  repeat j from rows - 2 to yloc
    '   longmove(i + cols, i, cols/4)           ' shift one line down
    '   i -= cols                               ' move i up one line

    i += cols                                 ' point to start of last line moved

  longfill(i, $20202020, cols/4)              ' clear the last line moved

  
  j := i - cols + xloc                        ' point to original cursor location
  bytemove(i, j, cols - xloc)                 ' move chars from cursor pos down to start of next line

  bytefill(j, $20, cols - xloc)               ' clear original part of line that was moved

  xloc := cursor[0] := 0                      ' reset xloc, loc and cursor position
  cursor[1] := yloc
  loc  := yloc*cols
PRI linefeed | i, j, len
  if ++yloc == rows                            ' if last line on screen, shift all up
    yloc--                                    ' reset yloc it at bottom of screen
    i := @screen


    i += cols
    
    len := (chars1 - cols)/4           'rows*cols    (rows*cols)
    longmove(@screen, i, len)                 ' shift screen up one line
    
    i := @screen
    i += ((rows*cols) - cols)              ' set "i" for use below

  else                                        ' if not last line, shift lines down
    i := @screen
    i += (rows - 2)*cols                      ' init ptr to start of next-to-last line  was -2 now -1
    i += cols                                 ' point to start of last line moved     
  longfill(i, $20202020, cols/4)              ' clear the last line moved   
  'j := i - cols + xloc                        ' point to original cursor location
  j := i + xloc
  bytemove(i, j, cols - xloc)                 ' move chars from cursor pos down to start of next line

  bytefill(j, $20, cols - xloc)               ' clear original part of line that was moved

  cursor[1] := yloc
  cursor[0] := xloc
  loc := xloc + (yloc*cols)
PUB out(c) | i, j
'' Print a character
''
''  $09 = tab
''  $0A = Linefeed
''  $0D = return -> CR
''  $20..$7E = display character
''  $7F = skip
'' ones above this not implemented as CP/M can't handle these
''  $C0   left arrow
''  $C1 = right arrow
''  $C2 = up arrow
''  $C3 = down arrow
''  $C4 = home key - go to beginning of line
''  $C5 = end key - go past last char on line
''  $C6 = page up key - skip this key
''  $C7 = page down key - skip this key
''  $C8 = backspace key
''  $C9 = delete key
''  $CA = insert key - skip this key
''  $CB = esc - skip this key
''  $CC = left arrow don't scroll up
  case c
    $09:                        ' tab command
      repeat
        out($C1)                ' recursive call to out( )
      while xloc & 7            ' tab to multiples of 8 
      'while xloc & 3            ' tab to multiples of 4 
    $0A:
      linefeed
    $0D:                        ' CR, return to start of line
      if xloc
         repeat
           out($C0)                ' recursive call to shift left until at leftmost edge
         while xloc  
    $20..$7E:                   ' character
      
      if inverse==1             'check for inverse character mode
        c:=c + $80                'add for inverse bit 1 set
      if ++xloc == cols1
         xloc := xloc - 1
         newline
         xloc := cursor[0] := 1
      screen[loc++] := c        ' output the character       
      cursor[0] := xloc
      cursor[1] := yloc



    $C0:                        ' left arrow needed for code above
      if loc                    ' skip this if at upper left screen
        loc--
        if xloc
          xloc--
        else
          xloc := cols - 1
          yloc--
        cursor[0] := xloc
        cursor[1] := yloc



    $C1:                        ' right arrow also needed for code above
      if loc <> chars1 - 1       ' skip if at lower right of screen
        loc++
        if xloc <> cols - 1
          xloc++
        else
          xloc := 0
          yloc++
        cursor[0] := xloc
        cursor[1] := yloc
{
    $C2:                        ' up arrow
      if yloc                   ' skip if yloc at top of screen
        yloc--                  ' move yloc up one row
        loc -= cols             ' move loc var back one row
        cursor[1] := yloc       ' reset 'y' cursor position

    $C3:                        ' down arrow
      if yloc <> rows - 1    ' skip if at bottom of screen
        yloc++                  ' move yloc dowm one row
        loc += cols             ' move loc var down one row
        cursor[1] := yloc

    $C4:                        ' home key - move to 1st char of line
      xloc := cursor[0] := 0
      loc := xloc + yloc*cols

    $C5:                        ' end key - move to last char of line
      if xloc <> cols - 1
        repeat xloc from cols - 1 to 0
         loc := xloc + yloc*cols
         if screen[loc] <> $20  ' continue until first non-space char
           if xloc <> cols - 1
             xloc++               ' move past non-blank char
             loc++
           quit

        cursor[0] := xloc       ' loc is already reset from above
}

    $08:                        ' backspace
      if loc                    ' skip if at upper left of screen
        if xloc                 ' do 'else' if at start of line
          xloc--                ' xloc left one space
          loc--

          i := @screen          ' calculate
          i += xloc + yloc*cols ' destination for shift left one
          bytemove(i, i+1, cols - xloc - 1)
          screen[cols - 1 + yloc*cols] := $20

        else                    ' here if xloc == 0
          if screen[loc-1] == $20   ' last char on prev line
            yloc--

            i := @screen          ' calculate
            i += loc - 1          ' destination for shift left one

            repeat while screen[--loc] == $20
              bytemove(i, i+1, cols) ' move one row's worth of chars
              i--                 ' dec "i" to correspond to --loc

              screen[loc + cols] := $20  ' clear old char

              if ++xloc == cols   ' use xloc as counter here, 0..., don't move > 1 row
                loc--             ' make as if loc had been bumped above B4 we quit
                quit

            loc++                 ' bump loc to space char
            xloc := loc - yloc*cols ' re-calculate xloc from loc and yloc

        cursor[0] := xloc         ' reset cursor loc
        cursor[1] := yloc
{
    $C9:                          ' delete
      if xloc == cols - 1
        screen[loc] := $20        ' if at last char on line, clear it and exit

      else
        repeat i from xloc to cols - 2
          j := i + yloc*cols
          screen[j] := screen[j+1]

       screen[j+1] := $20       ' clear last char on line after shift left
}
PUB str(string_ptr)

'' Print a zero terminated string

  repeat strsize(string_ptr)
    out(byte[string_ptr++])

DAT
' 8 x 12 font - characters 0..127
'
' Each long holds four scan lines of a single character. The longs are arranged into
' groups of 128 which represent all characters (0..127). There are three groups which
' each contain a vertical third of all characters. They are ordered top, middle, and
' bottom.
font  long

long  $0C080000,$30100000,$7E3C1800,$18181800,$81423C00,$99423C00,$8181FF00,$E7C3FF00  'top  ascii 0-7
long  $1E0E0602,$1C000000,$00000000,$00000000,$18181818,$18181818,$00000000,$18181818
long  $00000000,$18181818,$18181818,$18181818,$18181818,$00FFFF00,$CC993366,$66666666
long  $AA55AA55,$0F0F0F0F,$0F0F0F0F,$0F0F0F0F,$0F0F0F0F,$00000000,$00000000,$00000000  ' ascii 24 to 31
long  $00000000,$3C3C1800,$66666600,$7F363600,$667C1818,$46000000,$1B1B0E00,$1C181800  ' 77666600  to 66666600 for the " character (ascii 32
long  $0C183000,$180C0600,$66000000,$18000000,$00000000,$00000000,$00000000,$60400000
long  $73633E00,$1E181000,$66663C00,$60663C00,$3C383000,$06067E00,$060C3800,$63637F00
long  $66663C00,$66663C00,$1C000000,$00000000,$18306000,$00000000,$180C0600,$60663C00
long  $63673E00,$66663C00,$66663F00,$63663C00,$66361F00,$06467F00,$06467F00,$63663C00
long  $63636300,$18183C00,$30307800,$36666700,$06060F00,$7F776300,$67636300,$63361C00
long  $66663F00,$63361C00,$66663F00,$66663C00,$185A7E00,$66666600,$66666600,$63636300
long  $66666600,$66666600,$31637F00,$0C0C3C00,$03010000,$30303C00,$361C0800,$00000000
long  $0C000000,$00000000,$06060700,$00000000,$30303800,$00000000,$0C6C3800,$00000000
long  $06060700,$00181800,$00606000,$06060700,$18181E00,$00000000,$00000000,$00000000
long  $00000000,$00000000,$00000000,$00000000,$0C080000,$00000000,$00000000,$00000000
long  $00000000,$00000000,$00000000,$18187000,$18181800,$18180E00,$73DBCE00,$18180000

long  $080C7E7E,$10307E7E,$18181818,$7E181818,$81818181,$99BDBDBD,$81818181,$E7BD99BD  'middle
long  $1E3E7E3E,$1C3E3E3E,$30F0C000,$0C0F0300,$00C0F030,$00030F0C,$00FFFF00,$18181818
long  $18FFFF00,$00FFFF18,$18F8F818,$181F1F18,$18FFFF18,$00FFFF00,$CC993366,$66666666
long  $AA55AA55,$FFFF0F0F,$F0F00F0F,$0F0F0F0F,$00000F0F,$FFFF0000,$F0F00000,$0F0F0000  ' 00000033 to 00000066 for the " character
long  $00000000,$0018183C,$00000066,$7F363636,$66603C06,$0C183066,$337B5B0E,$0000000C
long  $0C060606,$18303030,$663CFF3C,$18187E18,$00000000,$00007E00,$00000000,$060C1830
long  $676F6B7B,$18181818,$0C183060,$60603860,$307F3336,$60603E06,$66663E06,$0C183060
long  $66763C6E,$60607C66,$1C00001C,$00001C1C,$180C060C,$007E007E,$18306030,$00181830
long  $033B7B7B,$66667E66,$66663E66,$63030303,$66666666,$06263E26,$06263E26,$63730303
long  $63637F63,$18181818,$33333030,$36361E36,$66460606,$63636B7F,$737B7F6F,$63636363
long  $06063E66,$7B636363,$66363E66,$66301C06,$18181818,$66666666,$66666666,$366B6B63
long  $663C183C,$18183C66,$43060C18,$0C0C0C0C,$30180C06,$30303030,$00000063,$00000000
long  $0030381C,$333E301E,$6666663E,$0606663C,$3333333E,$067E663C,$0C0C3E0C,$3333336E
long  $66666E36,$1818181C,$60606070,$361E3666,$18181818,$6B6B6B3F,$6666663E,$6666663C
long  $6666663B,$3333336E,$066E7637,$300C663C,$0C0C0C7E,$33333333,$66666666,$6B6B6363
long  $1C1C3663,$66666666,$0C30627E,$180C060C,$18181818,$18306030,$00000000,$0018187E

long  $00000000,$00000000,$00001818,$0000183C,$00003C42,$00003C42,$0000FF81,$0000FFC3  'bottom
long  $0002060E,$00000000,$18181818,$18181818,$00000000,$00000000,$00000000,$18181818
long  $18181818,$00000000,$18181818,$18181818,$18181818,$00FFFF00,$CC993366,$66666666
long  $AA55AA55,$FFFFFFFF,$F0F0F0F0,$0F0F0F0F,$00000000,$FFFFFFFF,$F0F0F0F0,$0F0F0F0F
long  $00000000,$00001818,$00000000,$00003636,$0018183E,$00006266,$00006E3B,$00000000
long  $00003018,$0000060C,$00000000,$00000000,$0C181C1C,$00000000,$00001C1C,$00000103
long  $00003E63,$00007E18,$00007E66,$00003C66,$00007830,$00003C66,$00003C66,$00000C0C
long  $00003C66,$00001C30,$0000001C,$0C181C1C,$00006030,$00000000,$0000060C,$00001818
long  $00003E07,$00006666,$00003F66,$00003C66,$00001F36,$00007F46,$00000F06,$00007C66
long  $00006363,$00003C18,$00001E33,$00006766,$00007F66,$00006363,$00006363,$00001C36
long  $00000F06,$00603C36,$00006766,$00003C66,$00003C18,$00003C66,$0000183C,$00003636
long  $00006666,$00003C18,$00007F63,$00003C0C,$00004060,$00003C30,$00000000,$FFFF0000
long  $00000000,$00006E33,$00003B66,$00003C66,$00006E33,$00003C66,$00001E0C,$1E33303E
long  $00006766,$00007E18,$3C666660,$00006766,$00007E18,$00006B6B,$00006666,$00003C66
long  $0F063E66,$78303E33,$00000F06,$00003C66,$0000386C,$00006E33,$0000183C,$00003636
long  $00006336,$1C30607C,$00007E46,$00007018,$00001818,$00000E18,$00000000,$0000007E

    
{
PUB txVT100(remote) | i,j,k,remote2,record,loop,var1,col,row,temp2,tempbaud,source' process the VT100 codes

' variables byte1 to byte7, vt100, wyse and W1-3 are all global so stay static each call

      if remote == 27                                                                                   'vt100 ESC code is being sent
         vt100:=1
         byte1:=0
         byte2:=0
         byte3:=0
         byte4:=0
         byte5:=0
         byte6:=0
         byte7:=0
         remote:=0
         temp2:=0
         wyse:=0
         w1:=0
         w2:=0
         w3:=0

           ' removed the skip for esc= and put it further down
      'if remote==61
       ' vt100:=0
       ' remote:=0
                                                                                             'Don't display the ESC code
      if remote == 99 and vt100 == 1                                                                    'ESC c
         remote:=0
         vt100:=0
         inv(0)
         ClearScreen
         Home

      ' wyse command to clear screen = Esc;
      if remote==59 and vt100==1 and wyse==0
          vt100:=0
          remote:=0
          ClearScreen
          Home
      ' another wyse command to clear the screen is Esc*
      if remote==42 and vt100==1 and wyse==0
          vt100:=0
          remote:=0
          ClearScreen
          Home


          'put ESC D and ESC M here
      if remote == 77 and vt100 == 1 'AKA ESC M
         scrollM
         vt100 := 0
      if remote == 68 and vt100 == 1 'AKA ESC D
         if byte2 <> 91 and byte3 <> 91 and byte4 <> 91  'not esc[D
            'text.scrollD
            vt100 := 0
      if remote == 76 and vt100 == 1 'AKA ESC L
      if remote == 91 and vt100 == 1 ' [                'look for open bracket [
         vt100:=2
        ' begin wyse
      if remote==61 and vt100==1 and wyse==0            ' wyse command for Esc=
         wyse:=61
      if remote==46 and vt100==1 and wyse==0            ' wyse command for Esc.
         wyse:=46
      if wyse==61 or wyse==46
        w3:=w2                                          ' wyse mini buffer , only needs a few characters as codes are short
        w2:=w1
        w1:=remote
        remote:=0                                       ' so doesn't print character
      if w3==61 and wyse==61                            ' an Esc=RC
        col:=w1-32
        row:=w2-32
        cursloc(col,row)
        vt100:=0                                        ' clear pointer
        wyse:=0                                         ' clear vt100 pointer too
        remote:=0                                       ' hide character from output
      if w2==46 and w1==49 and wyse==46                 ' Esc.1
        vt100:=0                                        ' do nothing but do need to trap these (cursor on and off)
        wyse:=0
        remote:=0                                       ' hide character from output
      if w2==46 and w1==48 and wyse==46                 ' Esc.0
        vt100:=0
        wyse:=0
        remote:=0                                       ' hide character from output
         ' end wyse                                     'start recording code
      if remote == 62 and vt100 == 1 or remote == 60 and vt100 == 1     'look for < & >
         vt100:=0                                       ' not sure why this is coming up, can't find in spec.
      if vt100==2                                       ''Check checking for VT100 emulation codes
         if remote > 10
           byte7:=byte6
           byte6:=byte5                                 ' VTCode Mini Buffer
           byte5:=byte4
           byte4:=byte3
           byte3:=byte2                                 'Record the last 7 bytes backwards higher = earlier in string
           byte2:=byte1
           byte1:=remote

         if remote == 109                               'look for lowercase m
            if byte2 == 91                              'if [m turn off to normal set
               inv(0)
               vt100:=0
            if byte2 == 49 and vt100 > 0                'is it ESC[1m BOLD
               'inv(1)                                   'bold on commented out as using inverse instead and it is a bit harsh
               vt100 := 0
            if byte2  == 55 and vt100 > 0               'is it ESC[7m?
               inv(1)                                   ' bold off
               vt100 := 0
            if byte2  == 48 and vt100 > 0               '0 is back to normal
               inv(0)
               vt100:=0
            if byte2 == 52 and vt100 > 0                'is it ESC[4m underline?
               vt100:=0                                 'yes ignore
            if byte2 == 50 and vt100 >0                 'is it ESC[2m dim text
               vt100:=0
                                                        'yes ignore
         if remote == 64                                'look for ESC[value@ @=64   insert value spaces
            if byte4 == 91 'two digit value
               byte3:=byte3-48                          'Grab 10's
               byte2:=byte2-48                          'Grab 1's
               byte3:=byte3*10                          'Multiply 10's
               byte3:=byte3+byte2                       'Add 1's
               insertat(byte3)
            if byte3 == 91 'single digit value
               byte2:=byte2-48
               insertat(byte2)
            vt100 :=0
         if remote == 80                                'look for ESC[valueP P=64   delete value spaces
            if byte4 == 91 'two digit value
               byte3:=byte3-48                          'Grab 10's
               byte2:=byte2-48                          'Grab 1's
               byte3:=byte3*10                          'Multiply 10's
               byte3:=byte3+byte2                       'Add 1's
               delp(byte3)
            if byte3 == 91 'single digit value
               byte2:=byte2-48
               delp(byte2)
            vt100 :=0
         if remote == 104                               'look for lowercase h set CR/LF mode
            if byte2 == 48                              'if character before h is 0 maybe command is 20h
               if byte3 == 50                           'if byte3 then it is for sure 20h
                 LNM := 0
            vt100:=0

         if remote == 61                                'lool for =
            vt100:=0

         if remote == 114                               'look for lowercase r
            vt100:=0

         if remote == 108                               'look for lowercase l
            if byte2 == 48                              'if character before l is 0 maybe command is 20l
               if byte3 == 50                           'if byte3 then it is for sure 20l
                 LNM := 1                               '0 means CR/LF in CR mode only
            vt100:=0

         if remote == 62  'look for >
            vt100:=0
         if remote == 77                                'ESC M look for obscure scroll window code
            scrollM
            vt100:=0
         if remote == 68 or remote == 76                ' look for ESC D  or ESC L
            scrollD
            vt100:=0
         if remote == 72 or remote == 102               ' HOME CURSOR (uppercase H or lowercase f)
            if byte2==91 or byte2==59                   'look for [H or [;f
               Home
               vt100:=0
            '' Check for X & Y with [H or ;f   -   Esc[Line;ColumnH

            else                                        'here remote is either H or f
              if byte4 == 59                            'is col is greater than 9     ; ALWAYS if byte4=59
                byte3:=byte3-48                         'Grab 10's
                byte2:=byte2-48                         'Grab 1's
                byte3:=byte3*10                         'Multiply 10's
                byte3:=byte3+byte2                      'Add 1's
                col:=byte3                              'Set cols

                if byte7 == 91                          'Assume row number is greater than 9  if ; at byte 4 and [ at byte 7 greater than 9
                   byte6:=byte6-48                      'Grab 10's
                   byte5:=byte5-48                      'Grab 1's
                   byte6:=byte6*10                      'Multiply 10's
                   byte6:=byte6+byte5                   'Add 1's
                   row:=byte6

                if byte6 == 91                          'Assume row number is less than 10
                   byte5:=byte5 - 48                    'Grab 1's
                   row:=byte5

              if byte3 == 59                            ' Assume that col is less an 10
                byte2:=byte2-48                         'Grab 1's
                col:=byte2                              'set cols

                if byte6 == 91                          'Assume row number is greater than 9
                   byte5:=byte5-48                      'Grab 10's
                   byte4:=byte4-48                      'Grab 1's
                   byte5:=byte5*10                      'Multiply 10's
                   byte5:=byte5+byte4                   'Add 1's
                   row:=byte5
                if byte5 == 91                          'Assume that col is greater than 10
                   byte4:=byte4-48                      'Grab 1's
                   row:=byte4

              col:=col-1
              if row == -459
                 row:=1
              if col == -40                             ' Patches a bug I havn't found.  *yet*
                 col := 58                              ' A Microsoft approach to the problem. :)
              if row == -449
                 row := 2                               ' Appears to be an issue with reading
              if row == -439                            ' single digit rows.
                 row := 3
              if row == -429                            ' This patch checks for the bug and replaces
                 row := 4                               ' the faulty calculation.
              if row == -419
                 row := 5                               ' Add to list to find the source of bug later.
              if row == -409
                 row := 6
              if row == -399
                 row := 7
              if row == -389
                 row := 8
              if row == -379
                 row := 9
              row--


              if row < 0
                 row:=0
              if col < 0
                 col:=0
              if row > 39                               ' max rows
                 row :=39
              if col > 79                               ' max cols
                 col := 79
              cursloc(col,row)
            vt100:=0
         if remote == 114                               'ESCr
               out(126)
         if remote == 74                                '' CLEAR SCREEN
             if byte2==91                                '' look for [J  '' clear screen from cursor down
               clsfromcursordown
             if byte2==50                                '' look for [2J '' clear screen
               ClearScreen
            if byte2==49                                'look for [1J
               clstocursor
            if byte2==48                                'look for [0J
               clsfromcursordown
            vt100:=0
         if remote == 66                                ' CURSOR DOWN    Esc[ValueB
            if byte4 == 91                              ' Assume number over 10
              byte3:=byte3-48
              byte2:=byte2-48
              byte3:=byte3*10
              byte3:=byte3+byte2
              var1:=byte3
            if byte3 == 91                              ' Assume number is less 10
              byte2:=byte2-48
              var1:=byte2
            if byte2 == 91                              'ESC[B no numbers move down one
              'text.out($C3)
              var1 := 1
            loop:=0
            repeat until loop == var1
               loop++
               out($C3)

            vt100:=0


         if remote == 65                                ' CURSOR UP   Esc[ValueA
            if byte4 == 91                              ' Assume number over 10
              byte3:=byte3-48
              byte2:=byte2-48
              byte3:=byte3*10
              byte3:=byte3+byte2
              var1:=byte3
            if byte3 == 91                              ' Assume number is less 10
              byte2:=byte2-48
              var1:=byte2
            if byte2 == 91                              'ESC[A no numbers move down one

              var1 := 1
            loop:=0
            repeat until loop == var1
               out($C2)
               loop++
            vt100:=0


         if remote == 67                                ' CURSOR RIGHT   Esc[ValueC
            if byte4 == 91                              ' Assume number over 10
              byte3:=byte3-48
              byte2:=byte2-48
              byte3:=byte3*10
              byte3:=byte3+byte2
              var1:=byte3
            if byte3 == 91                              ' Assume number is less 10
              byte2:=byte2-48
              var1:=byte2
            if byte2 == 91                              'ESC[C no numbers move RIGHT one

              var1 := 1
            loop:=0
            repeat until loop == var1
               out($C1)
               loop++
            vt100:=0

         if remote == 68                                ' CURSOR LEFT   Esc[ValueD  OR ESC[D
            if byte4 == 91                              ' Assume number over 10
              byte3:=byte3-48
              byte2:=byte2-48
              byte3:=byte3*10
              byte3:=byte3+byte2
              var1:=byte3
            if byte3 == 91                              ' Assume number is less 10
              byte2:=byte2-48
              var1:=byte2
            if byte2 == 91                              'ESC[D no numbers move LEFT one

              var1 := 1
            loop:=0
            repeat until loop == var1
               out($C0)                         'was $C0
               loop++
            vt100:=0

         if remote == 75                                '' Clear line  Esc[K
           if byte2 == 91                               '' Look for [
             clearlinefromcursor

             vt100:=0
           if byte2  == 48 ' look for [0K
              if byte3 == 91
                 clearlinefromcursor

                 vt100:=0
           if byte2 == 49  ' look for [1K
              if byte3 == 91
                 clearlinetocursor
                 vt100 := 0
           if byte2 == 50 ' look for [2K
              if byte3 == 91
                 clearline
                 vt100 := 0

         if remote == 99                                ' look for [0c or [c ESC [ ? 1 ; Ps c Ps=0 for VT-100 no options
           if byte2 == 91                               ' Look for [
   '             ser2.str(string(27,"[?1;0c"))
                vt100 := 0
           if byte2 == 48
                if byte3 == 91
   '                  ser2.str(string(27,"[?1;0c"))
                     vt100 := 0
         remote:=0 '' hide all codes from the VGA output.

      if remote > 7
         out(remote)
}